/*
	File:		DocFile.h

	Contains:	A simple document file
				
	Written by: Jon Summers
	
	Copyright:	 1994 by Jon Summers, all rights reserved.

	Change History (most recent first):
	 
 */

#ifndef		_DOCFILE_
#define		_DOCFILE_

#ifndef	_APPCONDITIONALS_
	#include	"AppConditionals.h"
#endif

#define		ValidDataRefNum(n)			(n != 0)
#define		kInvalidDataRefNum			0

#define		ValidRsrcRefNum(n)		(n > 1)
#define		kInvalidRsrcRefNum		-1

/****
	Permissions:
		fsCurPerm, 
		fsRdPerm,
		fsWrPerm,
		fsRdWrPerm,
		fsRdWrShPerm,
****/
class	TDocFile
{
	public:
						TDocFile();
	virtual 				~TDocFile();

		void		SetFSSpec(FSSpec* pFSSpec);
		void		GetFSSpec(FSSpec* pFSSpec);
		void  	SetForkAvail(Boolean theData, Boolean theRsrc);
		void		OpenDataFork(char thePermission = fsRdWrPerm);
		void		CloseDataFork(void);
		void		OpenRsrcFork(char thePermission = fsRdWrPerm);
		void		CloseRsrcFork(void);
		void		Close(void);
		OSErr		GetLastFileError(void)	 { return fErr; }
	protected:
		OSErr			fErr;
		FSSpec		fSpec;
		short			fDataRefNum;
		short			fRsrcRefNum;
		Boolean		fHasDataFork;
		Boolean		fHasRsrcFork;
};

#endif
